/*
 * EmbedTest.java
 * JUnit based test
 *
 * Created on 26 April 2007, 21:23
 */

package test;

import java.util.EnumSet;
import javax.persistence.*;
import junit.framework.*;

/**
 *
 * @author Michael
 */
public class EmbedTest extends TestCase
{

    protected final static EntityManagerFactory emf = Persistence.createEntityManagerFactory("datingPU");
    
    public EmbedTest(String testName)
    {
        super(testName);
    }

    protected void setUp() throws Exception
    {
    }

    protected void tearDown() throws Exception
    {
    }
    
    public void testSearch() throws Exception
    {
        EntityManager em = emf.createEntityManager();
        try
        {
            EntityTransaction tx = em.getTransaction();
            tx.begin();
            try
            {
                
                doSearchTest(em, tx);
                
                tx.commit();
            }
            finally
            {
                if (tx.isActive())
                    tx.rollback();
            }
        }
        finally
        {
            em.close();
        }
    }
    
    private void doSearchTest(EntityManager em, EntityTransaction tx) throws Exception
    {
        Owner o = new Owner();
        Me    m = new Me();
        You   y = new You();
        
        o.setMe(m);
        o.setYou(y);
        
        m.setHair(Hair.Black);
        y.setHair(EnumSet.of(Hair.Black, Hair.Blond));
        
        em.persist(o);
        
        tx.commit();
        tx.begin();
        
        Query q = em.createQuery("SELECT o FROM Owner o WHERE LOCATE(o.me.hairString, o.you.hairString)>0");
        
        assertEquals(1, q.getResultList().size());
    }
}
