/*
 * AboutYou.java
 *
 * Created on 26 April 2007, 21:24
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package test;

import java.io.Serializable;
import java.util.EnumSet;
import java.util.Set;
import java.util.StringTokenizer;
import javax.persistence.*;

/**
 *
 * @author Michael
 */
@Embeddable
public class You implements Serializable
{
    private Set<Hair>   hair;
    
    /** Creates a new instance of AboutYou */
    public You()
    {
    }
    
    
    @Transient
    public Set<Hair> getHair()
    {
        return hair;
    }
    public void setHair(Set<Hair> hair)
    {
        this.hair = hair;
    }
    
    @Basic
    @Column(name = "you_hair")
    public String getHairString()
    {
        return hair == null ? null : enumSetToString(Hair.class, hair);
    }
    public void setHairString(String names)
    {
        this.hair = names == null ? null : stringToEnumSet(Hair.class, names);
    }
    
    
    
    
    public static <T extends Enum<T>> String enumSetToString(Class<T> eclass, Set<T> set)
    {
        String string = "";
        StringBuilder sb = null;
        for (T t : set)
        {
            if (sb != null)
                sb.append(',').append(t);
            else if (string != "")
                sb = new StringBuilder(string).append(',').append(t);
            else
                string = t.toString();
        }
        return sb != null ? sb.toString() : string;
    }
    
    
    /* Create an EnumSet of the comma seperate string of enum names.
     * @param eclass the class of the enum
     * @param string the comma seperated string of enum names
     * @return an EnumSet
     */
    public static <T extends Enum<T>> EnumSet<T> stringToEnumSet(Class<T> eclass, String string)
    {
        EnumSet<T> enumSet = EnumSet.noneOf(eclass);
        for (StringTokenizer st = new StringTokenizer(string, ","); st.hasMoreTokens(); )
        {
            String s = st.nextToken();
            enumSet.add(Enum.valueOf(eclass, s));
        }
        return enumSet;
    }
}
